﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Models.Aqo
{
    public class AFPUtils
    {
        public static string GetParamName(ushort id)
        {
            switch(id)
            {
            #region ROOT
            case 0x0200: return "Desc";
            #endregion

            #region OBJC
            case 0x0810: return "fixed:3114";       // Check     ((uint)j.Value, 3114);                                                           break; // [1]
            case 0x0811: return "fixed:164";        // Check     ((uint)j.Value, 164);                                                            break; // [1]
            case 0x0912: return "9-31";	            // Check     ((uint)j.Value, 18, 17, 12, 20, 11, 10, 9, 22, 21, 19, 13, 27, 31, 23, 29, 26);  break; // [16]
            case 0x0813: return "VertSize";	        // Check     ((uint)j.Value, 76, 56, 32, 52, 44, 60, 68, 48, 84);                             break; // [9]
            case 0x0914: return "TotalNumIndex";	// CheckRange((uint)j.Value, 3, 25629);                                                       break; // [1561]
            case 0x0815: return "TotalNumVertex";	// CheckRange((uint)j.Value, 3, 13281);                                                       break; // [1237]
            case 0x0816: return "NumVSET";	        // CheckRange((uint)j.Value, 1, 118);                                                         break; // [64]
            case 0x0924: return "NumVSET2";	        // CheckRange((uint)j.Value, 1, 118);                                                         break; // [64]
            case 0x0925: return "NumVSET3";	        // CheckRange((uint)j.Value, 1, 118);                                                         break; // [64]
            case 0x0917: return "NumPSET";	        // CheckRange((uint)j.Value, 1, 118);                                                         break; // [64]
            case 0x0818: return "NumMATE?";	        // Check     ((uint)j.Value, 1, 2, 3, 4, 5, 6, 7);                                            break; // [7]
            case 0x0819: return "NumREND?";	        // Check     ((uint)j.Value, 2, 1, 3, 4, 6, 5);                                               break; // [6]
            case 0x081A: return "NumSHAD";	        // Check     ((uint)j.Value, 1, 2, 3);                                                        break; // [3]
            case 0x081B: return "NumTSTA?";	        // Check     ((uint)j.Value, 3, 4, 5, 7, 2, 6, 0, 8, 9);                                      break; // [9]
            case 0x081C: return "NumSHAP";	        // Check     ((uint)j.Value, 1, 2, 3, 4);                                                     break; // [4]
            case 0x081D: return "NumTEXF";	        // Check     ((uint)j.Value, 3, 4, 5, 7, 2, 6, 0, 8, 9);                                      break; // [9]
            case 0x0A1F: return "0x0A1F:1";
            case 0x4A1E: return "Center?";
            case 0x4A20: return "BB-Center?";
            case 0x4A21: return "BB-Extents?";
            #endregion

            #region VSET
            case 0x09B6: return "VertSize";	        // Check     ((uint)j.Value, 76, 56, 32, 52, 24, 48, 44, 64, 40, 60, 68, 84);                 break; // [12]
            case 0x09BF: return "NumElem";          // Check     ((uint)j.Value, 7, 5, 3, 6, 8);                                                  break; // [5]
            case 0x09B9: return "NumVert";          // CheckRange((uint)j.Value, 3, 8454);                                                        break; // [1393]
            case 0x09C4: return "fixed:0";          // Check     ((uint)j.Value, 0)       ;                                                       break; // [1]
            case 0x08BD: return "NumBone";          // Check     ((uint)j.Value, 1, 2, 3, 0, 6, 9, 13, 7, 5, 8, 4, 10, 12, 16, 11, 14, 15);       break; // [17]
            case 0x09C8: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x09CC: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x09C9: return "0-1414";           // CheckRange((uint)j.Value, 0, 1414);                                                        break; // [63]
            case 0x86BE: return "Bones";
            case 0x86CA: return "0x86CA";
            #endregion

            #region VTXE
            case 0x09D0: return "ElemUsage";        // Check     ((uint)j.Value, 0, 1, 2, 33, 32, 11, 16, 3, 4, 17);                              break; // [10]
            case 0x09D1: return "ElemType";         // Check     ((uint)j.Value, 3, 4, 7, 2, 5);                                                  break; // [5]
            case 0x09D2: return "ElemOffset";       // Check     ((uint)j.Value, 0, 12, 28, 40, 52, 64, 68, 24, 36, 48, 44, 16, 32, 56, 60, 76);  break; // [16]
            case 0x09D3: return "ElemIndex";        // Check     ((uint)j.Value, 0);                                                              break; // [1]
            #endregion

            #region VTXL
            case 0x89BA: return "VertBuffer";
            #endregion

            #region PSET
            case 0x09C6: return "fixed:8448";       // Check     ((uint)j.Value, 8448);                                                           break; // [1]
            case 0x09BB: return "fixed:1";          // Check     ((uint)j.Value, 1);                                                              break; // [1]
            case 0x09BC: return "NumIndex1";        // CheckRange((uint)j.Value, 3, 17327);                                                       break; // [2111]
            case 0x09B7: return "NumIndex2";        // CheckRange((uint)j.Value, 3, 17327);                                                       break; // [2111]
            case 0x09C5: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x86B8: return "Indices";
            #endregion

            #region MESH
            case 0x09B0: return "0x09B0";           // Check     ((uint)j.Value, 1048594, 17, 1048588, 1048596, 1048585, 1048586, 9, 20, 10, 1048593, 12, 18, 42, 50); break; // [14]
            case 0x09C7: return "0x09C7";           // CheckRange((uint)j.Value, 23680, 27520);                                                   break; // [196]
            case 0x08B1: return "IndexMATE";        // Check     ((uint)j.Value, 0, 1, 2, 3, 4, 5, 6);                                            break; // [7]   AlphaBlend?
            case 0x08B2: return "IndexREND";        // Check     ((uint)j.Value, 0, 1, 2, 3, 4, 5);                                               break; // [6]   AlphaBlend?
            case 0x08B3: return "IndexSHAD";        // Check     ((uint)j.Value, 0, 1, 2);                                                        break; // [3]
            case 0x08B4: return "IndexTSET?";       // Check     ((uint)j.Value, 0, 1, 2, 3);                                                     break; // [4]
            case 0x08B5: return "0x08B5";           // CheckRange((uint)j.Value, 0, 86);                                                          break; // [49]
            case 0x08C0: return "IndexVSET?";	    // CheckRange((uint)j.Value, 0, 117);                                                         break; // [118]
            case 0x08C1: return "IndexPSET?";	    // CheckRange((uint)j.Value, 0, 117);                                                         break; // [118]
            case 0x08CD: return "fixed:0";	        // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x09C2: return "fixed:0";	        // Check     ((uint)j.Value, 0);                                                              break; // [1]
            #endregion

            #region MATE
            case 0x0934: return "0,2,4";            // Check     ((uint)j.Value, 0, 2, 4);                                                        break; // [3]
            case 0x0937: return "0x0937";           // Check     ((uint)j.Value, 90, 100, 105, 99, 102, 101, 106, 104, 97, 96, 95, 98, 110);      break; // [13]
            case 0x0938: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x4A30: return "0x4A30";
            case 0x4A31: return "0x4A31";
            case 0x4A32: return "0x4A32";
            case 0x4A33: return "0x4A33";
            case 0x0A35: return "0x0A35";
            case 0x0A36: return "0x0A36";
            case 0x023A: return "MatName";
            case 0x0239: return "MatBaseName";
            #endregion

            #region REND
            case 0x0940: return "fixed:511";        // Check     ((uint)j.Value, 511);                                                            break; // [1]
            case 0x0941: return "1,3";              // Check     ((uint)j.Value, 3, 1);                                                           break; // [2]
            case 0x0942: return "1,2";              // Check     ((uint)j.Value, 2, 1);                                                           break; // [2]
            case 0x0943: return "AlphaEnable";      // Check     ((uint)j.Value, 1, 0);                                                           break; // [2]
            case 0x0944: return "fixed:5";          // Check     ((uint)j.Value, 5);                                                              break; // [1]
            case 0x0945: return "2,6";              // Check     ((uint)j.Value, 6, 2);                                                           break; // [2]
            case 0x0946: return "fixed:1";          // Check     ((uint)j.Value, 1);                                                              break; // [1]
            case 0x0947: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0948: return "fixed:5";          // Check     ((uint)j.Value, 5);                                                              break; // [1]
            case 0x0949: return "fixed:6";          // Check     ((uint)j.Value, 6);                                                              break; // [1]
            case 0x094A: return "fixed:1";          // Check     ((uint)j.Value, 1);                                                              break; // [1]
            case 0x094B: return "0,1";              // Check     ((uint)j.Value, 1, 0);                                                           break; // [2]
            case 0x094C: return "fixed:5";          // Check     ((uint)j.Value, 5);                                                              break; // [1]
            case 0x094D: return "AlphaRef:0,128";	// Check     ((uint)j.Value, 0, 128);                                                         break; // [2]
            case 0x094E: return "fixed:1";	        // Check     ((uint)j.Value, 1);                                                              break; // [1]
            case 0x094F: return "fixed:4";	        // Check     ((uint)j.Value, 4);                                                              break; // [1]
            case 0x0950: return "0,1";	            // Check     ((uint)j.Value, 0, 1);                                                           break; // [2]
            #endregion

            #region SHAD
            case 0x0990: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0993: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0291: return "0x0291";
            case 0x0292: return "0x0292";
            #endregion

            #region SHAP
            #endregion

            #region TSTA
            case 0x0960: return "fixed:22";         // Check     ((uint)j.Value, 22);                                                             break; // [1]
            case 0x0961: return "0,1,2,3,6";        // Check     ((uint)j.Value, 0, 1, 2, 3, 6);                                                  break; // [5]
            case 0x0962: return "0,1,-1";           // Check     ((uint)j.Value, 0, 4294967295, 1);                                               break; // [3]
            case 0x0964: return "fixed:0";	        // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0965: return "fixed:0";	        // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0966: return "fixed:0";	        // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0967: return "1,3";              // Check     ((uint)j.Value, 1, 3);                                                           break; // [2]
            case 0x0968: return "1,3";              // Check     ((uint)j.Value, 1, 3);                                                           break; // [2]
            case 0x0969: return "fixed:1";          // Check     ((uint)j.Value, 1);                                                              break; // [1]
            case 0x0A6A: return "0x0A6A";
            case 0x0A6B: return "0x0A6B";
            case 0x4A63: return "ColorNum?";
            case 0x026C: return "TexFile";
            #endregion

            #region TSET
            case 0x0970: return "0,1";              // Check     ((uint)j.Value, 0, 1);                                                           break; // [2]
            case 0x0871: return "NumTex?";          // Check     ((uint)j.Value, 3, 4, 1, 2, 0);                                                  break; // [5]
            case 0x0972: return "0,2";              // Check     ((uint)j.Value, 0, 2);                                                           break; // [2]
            case 0x0973: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x0974: return "fixed:0";          // Check     ((uint)j.Value, 0);                                                              break; // [1]
            case 0x8875: return "0x8875";
            #endregion

            #region TEXF
            case 0x0280: return "0x0280";
            #endregion

            #region UNRM
            case 0x09DA: return "8-1624";           // CheckRange((uint)j.Value, 8, 1624);                                                        break; // [287]
            case 0x09DC: return "16-3760";          // CheckRange((uint)j.Value, 16, 3760);                                                       break; // [319]
            case 0x89DB: return "0x89DB";
            case 0x89DD: return "0x89DD";
            case 0x89DE: return "0x89DE";
            #endregion

            case 0x00FC: return "START";
            case 0x00FD: return "END";
            case 0x00FE: return "ELEM";

            default:     return "(unknown)";
            }
        }
    }
}
