﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SlimDX;

namespace Models.Aqo
{
    public class ExportMesh
    {
        public string                   Name                    { get; set; }
        public string                   Material                { get; set; }
        public MeshBuilder<Vector3>     Pos                     { get; set; }
        public MeshBuilder<Vector3>     Nrm                     { get; set; }
        public MeshBuilder<Vector3>     Tex                     { get; set; }

        public ExportMesh()
        {
            Pos = new MeshBuilder<Vector3>();
            Nrm = new MeshBuilder<Vector3>();
            Tex = new MeshBuilder<Vector3>();
        }

        public void AddFace(
            Tuple<Vector3, Vector3, Vector3> v0,
            Tuple<Vector3, Vector3, Vector3> v1,
            Tuple<Vector3, Vector3, Vector3> v2)
        {
            Pos.Add(v0.Item1); Nrm.Add(v0.Item2); Tex.Add(v0.Item3);
            Pos.Add(v1.Item1); Nrm.Add(v1.Item2); Tex.Add(v1.Item3);
            Pos.Add(v2.Item1); Nrm.Add(v2.Item2); Tex.Add(v2.Item3);
        }
    }

    public class ExportMeshSet
    {
        public Dictionary<string, ExportMesh> Meshes            { get; set; }
        public List<ExportMesh>         AllMeshes               { get; set; }

        public ExportMeshSet()
        {
            Meshes      = new Dictionary<string, ExportMesh>();
            AllMeshes   = new List<ExportMesh>();
        }

        public ExportMesh GetOrAdd(string name)
        {
            ExportMesh   mesh;

            if(!Meshes.TryGetValue(name, out mesh))
                Meshes.Add(name, mesh= new ExportMesh() { Name= name });

            return mesh;
        }

        public void Sweep()
        {
            AllMeshes.AddRange(Meshes.Values);
            Meshes.Clear();
        }
    }
}
