﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Models.Aqo
{
    public class ImpExpBase
    {
        public Config                   Config                  { get; set; }
        public bool                     Debug                   { get; set; }
        public bool                     Reverse                 { get; set; }
        public int                      Mode                    { get; set; }
        public float                    Magnify                 { get; set; }
        public GetVector3               GetPos                  { get; set; }
        public GetVector3               GetNrm                  { get; set; }
        public GetVector3               GetUV                   { get; set; }
        public List<string>             Messages                { get; set; }

        public ImpExpBase(Config config, bool exp)
        {
            Config  = config;
            Debug   = Config.Get("Debug", "False").ToUpper() == "TRUE";
            Magnify = float.Parse(Config.Get("Magnify", "1"));
            GetPos  = new GetVector3(Config.Get("X", "+X"), Config.Get("Y", "+Y"), Config.Get("Z", "-Z"), Magnify, exp);
            GetNrm  = new GetVector3(Config.Get("X", "+X"), Config.Get("Y", "+Y"), Config.Get("Z", "-Z"), exp);
            GetUV   = new GetVector3(Config.Get("U",  "U"), Config.Get("V",  "V"), exp);
            Reverse = Config.Get("Face", "Front") == "Back";
            Mode    = int.Parse(Config.Get("Mode", "0"));

            Messages= new List<string>();
        }

        public void AddMessage(string s)
        {
            Messages.Add(s);
        }

        public void AddMessage(string fmt, params object[] args)
        {
            AddMessage(string.Format(fmt, args));
        }
    }
}
